;
;  Copyright (C) 2004, Kurt W Dekker, PLBM Games, kwd@plbm.com, www.plbm.com
;
;  This program is free software; you can redistribute it and/or modify
;  it under the terms of the GNU General Public License as published by
;  the Free Software Foundation; either version 2 of the License, or
;  (at your option) any later version.
;
;  This program is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU General Public License for more details.
;
;  You should have received a copy of the GNU General Public License
;  along with this program; if not, write to the Free Software
;  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
WHLIM	=	3
MAXOB	=	20
YMOVE	=	2
MXLM	=	250
MXRM	=	6
UPD	=	62750
DATANUM	=	9
DATA	=	59000
ACCEL	=	1

	ORG	57000

ZZZ	CALL	ONETIM

	CALL	INIT

MAIN	XOR	A
	LD	(65450),A
	LD	HL,60672
	INC	(HL)
	CALL	KEYIN
	CALL	PRSC
	CALL	SHAPDO
	CAL	YOU
	CALL	UPD
	JP	MAIN

YOU	LD	A,(OLDIR)
	LD	(SHNUM),A
	LD	A,(UX)
	LD	(XP),A
	LD	A,(UY)
	LD	(YP),A
	XOR	A
	LD	(ONOFF),A
	CALL	PLOT
	CALL	DODECO
	LD	A,(UX)
	LD	(XP),A
	LD	A,(UY)
	LD	(YP),A
	LD	A,1
	LD	(ONOFF),A
	LD	A,(DIR)
	LD	(OLDIR),A
	LD	(SHNUM),A
	CALL	PLOT
	RET

SHAPDO	XOR	A
	LD	(STPTR),A
	LD	(PTR),A
SHAPLP	LD	A,(PTR)
	CALL	LOAD
	CALL	DO1SHAP
	LD	A,(PTR)
	CALL	SAVE
	LD	HL,PTR
	INC	(HL)
	LD	A,(HL)
	CP	MAXOB
	JP	NZ,SHAPLP
	RET

DO1SHAP	LD	A,(TYPE)
	OR	A
	RET	Z
	CP	1
	JP	Z,POD
	CP	2
	JP	Z,MEN
	CP	3
	JP	Z,LANDER
	CP	4
	JP	Z,LANDER
	RET

LANDER	LD	A,(FLAG)
	OR	A
	RET	Z
	LD	A,4
	LD	(SHNUM),A
	LD	A,(TYPE)
	CP	4
	JP	NZ,NOMUT1
	LD	A,5
	LD	(SHNUM),A
NOMUT1	LD	A,(X1)
	OR	A
	JP	NZ,NOE3
	LD	A,(XH)
	CP	239
	JP	NC,NOE3
	LD	(XP),A
	LD	A,(Y1)
	LD	(YP),A
	XOR	A
	LD	(ONOFF),A
	CALL	PLOT
NOE3	LD	A,(OPT)
	CP	1
	JP	NZ,NOTOP1
	LD	A,(Y1)
	CP	53
	JP	C,NOGRAB
	LD	A,0
	LD	(OPT),A
	JP	NOUDB
NOGRAB	INC	A
	INC	A
	LD	(Y1),A
	JP	NOUDB
NOTOP1	LD	A,(XM)
	CALL	SETDE
	LD	HL,(XH)
	ADD	HL,DE
	LD	A,(SPEED)
	CALL	SETDE
	ADD	HL,DE
	CALL	CLIP
	LD	(XH),HL
	LD	A,(YM)
	LD	HL,Y1
	LD	B,(HL)
	ADD	(HL)
	AND	63
	LD	(HL),A
	LD	A,(TYPE)
	CP	4
	JP	Z,NOUDB
	LD	A,(HL)
	SUB	2
	CP	52
	JP	C,NOUDB
	LD	(HL),B
	XOR	A
	LD	HL,YM
	SUB	(HL)
	LD	(HL),A
NOUDB	LD	A,(TYPE)
	CP	4
	JP	C,NOHUNT
	LD	A,(STPTR)
	OR	A
	JP	Z,NOHUNT
	XOR	A
	LD	(SPT1),A
HUNT	LD	A,(SPT1)
	ADD	A
	LD	E,A
	LD	D,0
	LD	HL,MENSTAK
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	EX	DE,HL
	LD	(HOLDHL),HL
	CALL	NEGHL
	LD	HL,(XH)
	INC	HL
	INC	HL
	ADD	HL,DE
	LD	A,H
	OR	A
	JP	NZ,FGTIT
	LD	A,L
	CP	5
	JP	NC,FGTIT
	LD	A,1
	LD	(OPT),A
	LD	HL,(HOLDHL)
	LD	(XH),HL
	JP	NOHUNT
FGTIT	LD	A,(SPT1)
	INC	A
	ADD	A
	LD	HL,STPTR
	CP	(HL)
	JP	NZ,HUNT

NOHUNT	LD	HL,TIME
	DEC	(HL)
	JP	NZ,NONWDR1
	CALL	RND
	AND	15
	ADD	8
	LD	(HL),A
	CALL	RND3PM
	LD	(XM),A
	CALL	RND1PM
	LD	(YM),A
NONWDR1	LD	A,(X1)
	OR	A
	JP	NZ,NOP3
	LD	A,(XH)
	CP	239
	JP	NC,NOP3
	LD	(XP),A
	LD	A,(Y1)
	LD	(YP),A
	LD	A,1
	LD	(ONOFF),A
	CALL	PLOT
NOP3	RET

POD	LD	A,(FLAG)
	OR	A
	RET	Z
	XOR	A
	LD	(SHNUM),A
	LD	A,(X1)
	OR	A
	JP	NZ,NOE1
	LD	A,(XH)
	CP	239
	JP	NC,NOE1
	LD	(XP),A
	LD	A,(Y1)
	LD	(YP),A
	XOR	A
	LD	(ONOFF),A
	CALL	PLOT
NOE1	CALL	RND
	CP	30
	CALL	C,RANDMV
	LD	HL,(XH)
	LD	A,(SPEED)
	CALL	SETDE
	ADD	HL,DE
	LD	(XH),HL
	LD	A,(X1)
	OR	A
	JP	NZ,NOP1
	LD	A,(XH)
	CP	239
	JP	NC,NOP1
	LD	(XP),A
	LD	A,(Y1)
	LD	(YP),A
	LD	A,255
	LD	(ONOFF),A
	CALL	PLOT
NOP1	RET

MEN	LD	A,(FLAG)
	OR	A
	RET	Z
	LD	A,58
	LD	(YP),A
	LD	A,1
	LD	(SHNUM),A
	LD	A,(X1)
	OR	A
	JP	NZ,NOE2
	LD	A,(XH)
	CP	239
	JP	NC,NOE2
	LD	(XP),A
	XOR	A
	LD	(ONOFF),A
	CALL	PLOT
NOE2	LD	A,(XM)
	CALL	SETDE
	LD	HL,(XH)
	ADD	HL,DE
	LD	A,(SPEED)
	CALL	SETDE
	ADD	HL,DE
	CALL	CLIP
	LD	(XH),HL
; DON'T DO IF MAN IN AIR!
	PUSH	HL
	LD	HL,STPTR
	LD	A,(HL)
	ADD	A
	LD	E,A
	INC	(HL)
	LD	D,0
	LD	HL,MENSTAK
	ADD	HL,DE
	POP	DE
	LD	(HL),E
	INC	HL
	LD	(HL),D

	LD	HL,YM
	DEC	(HL)
	JP	NZ,NONWDR
	CALL	RND
	AND	15
	ADD	8
	LD	(HL),A
AG1	CALL	RND
	AND	3
	JP	Z,AG1
	SUB	2
	LD	(XM),A
NONWDR	LD	A,(X1)
	OR	A
	JP	NZ,NOP2
	LD	A,(XH)
	CP	239
	JP	NC,NOP2
	LD	(XP),A
	LD	A,255
	LD	(ONOFF),A
	CALL	PLOT
NOP2	RET

RANDMV	CALL	RND
	AND	32
	JP	Z,RNDN
	LD	HL,Y1
	DEC	(HL)
	LD	A,(HL)
	AND	63
	LD	(HL),A
	JP	RNDH
RNDN	LD	HL,Y1
	INC	(HL)
	LD	A,(HL)
	AND	63
	LD	(HL),A
RNDH	CALL	RND
	AND	32
	JP	Z,RNDL
	LD	HL,(XH)
	INC	HL
	CALL	CLIP
	LD	(XH),HL
	JP	RNDE
RNDL	LD	HL,(XH)
	DEC	HL
	CALL	CLIP
	LD	(XH),HL
RNDE	RET

CLIP	LD	A,H
	AND	3
	LD	H,A
	RET

SETDE	LD	D,0
	LD	E,A
	AND	128
	RET	Z
	LD	D,255
	RET

KEYIN	DI
	LD	A,255
	OUT	177
	IN	178
	AND	254
	OUT	178
	IN	225
	CPL
	AND	16
	JP	NZ,KEYIN
	IN	225
	CPL
	AND	32
	LD	(SNDON),A
	IN	178
	OR	1
	OUT	178
	LD	A,191
	OUT	177
	IN	225
	CPL
	LD	(KEYSP),A
	LD	A,254
	OUT	177
	IN	225
	CPL
	LD	(KEY2),A
	LD	A,253
	OUT	177
	IN	225
	CPL
	LD	(KEY1),A
	EI
	RET

ONETIM	LD	HL,0
	LD	(SCORE),HL
	LD	A,4
	LD	(SHIS),A
	RET

INIT	LD	A,1
	LD	(YET),A
	LD	A,110
	LD	(UX),A
	LD	A,32
	LD	(UY),A
	LD	A,2
	LD	(DIR),A
	LD	(OLDIR),A
	XOR	A
	LD	(SPEED),A
	LD	(FIRE),A
	CALL	CLS
	CALL	INIT1
	CALL	INIT2
	CALL	INIT3
	RET

INIT1	LD	A,1
	LD	(FLAG),A
	XOR	A
	LD	(TYPE),A
	LD	(PTR),A
INIT1LP	LD	A,(PTR)
	CALL	SAVE
	LD	HL,PTR
	INC	(HL)
	LD	A,(HL)
	CP	MAXOB
	JP	NZ,INIT1LP
	RET

INIT2	LD	A,1
	LD	(TYPE),A
	XOR	A
	LD	(WHICH),A
	LD	(PTR),A
INIT2LP	LD	A,(WHICH)
	LD	E,A
	LD	D,0
	LD	HL,PODZ
	ADD	HL,DE
	LD	A,(HL)
	LD	(COUNT),A
INIT2L2	LD	A,(PTR)
	CALL	SAVE
	LD	HL,PTR
	INC	(HL)
	LD	A,(HL)
	CP	MAXOB
	RET	Z
	LD	HL,COUNT
	DEC	(HL)
	JP	NZ,INIT2L2
	LD	HL,TYPE
	INC	(HL)
	LD	HL,WHICH
	INC	(HL)
	LD	A,(HL)
	CP	WHLIM
	JP	NZ,INIT2LP
	RET

INIT3	XOR	A
	LD	(PTR),A
INIT3LP	LD	A,(PTR)
	CALL	LOAD
	LD	A,(TYPE)
	OR	A
	JP	Z,NOINIT
	CP	1
	CALL	Z,TIPE1
	CP	2
	CALL	Z,TIPE2
	CP	3
	CALL	Z,TIPE3
	LD	A,(PTR)
	CALL	SAVE
NOINIT	LD	HL,PTR
	INC	(HL)
	LD	A,(HL)
	CP	MAXOB
	JP	NZ,INIT3LP
	RET

RND1PM	CALL	RND
	AND	3
	JP	Z,RND1PM
	SUB	2
	RET

RND3PM	CALL	RND
	AND	3
	LD	B,A
	CALL	RND
	AND	32
	LD	A,B
	RET	Z
	XOR	A
	SUB	B
	RET

NEGHL	XOR	A
	SUB	L
	LD	L,A
	XOR	A
	CCF
	SBC	H
	LD	H,A
	RET

RNDHL	CALL	RND
	LD	H,A
	CALL	RND
	LD	L,A
	JP	CLIP

TIPE1	LD	A,1
	LD	(FLAG),A
	CALL	RNDHL
	LD	(XH),HL
	CALL	RND
	AND	63
	LD	(Y1),A
	LD	A,1
	RET

TIPE2	LD	A,1
	LD	(FLAG),A
	CALL	RNDHL
	LD	(XH),HL
	LD	A,1
	LD	(YM),A
	LD	A,2
	RET

TIPE3	LD	A,1
	LD	(FLAG),A
	CALL	RNDHL
	LD	(XH),HL
AG2	CALL	RND
	AND	63
	CP	48
	JP	NC,AG2
	ADD	4
	LD	(Y1),A
	XOR	A
	LD	(XM),A
	LD	(YM),A
	LD	A,1
	LD	(OPT),A
	LD	A,3
	RET

; DECODE KEYBOARD INPUT

DODECO	LD	A,(KEY2)
	AND	128
	JP	Z,NOTL
	LD	A,3
	LD	(DIR),A
	LD	HL,YET
	DEC	(HL)
	JP	NZ,NOTR
	LD	(HL),ACCEL
	LD	A,(SPEED)
	DEC	A
	CP	MXLM
	JP	Z,NOTR
	LD	(SPEED),A
	JP	NOTR
NOTL	LD	A,(KEY1)
	AND	128
	JP	Z,NOTR
	LD	A,2
	LD	(DIR),A
	LD	HL,YET
	DEC	(HL)
	JP	NZ,NOTR
	LD	(HL),ACCEL
	LD	A,(SPEED)
	INC	A
	CP	MXRM
	JP	Z,NTR
	LD	(SPEED),A
NOTR	LD	A,(KEY1)
	AND	1
	JP	Z,NOTUP
	LD	A,(UY)
	CP	4
	JP	C,NOTUP
	SUB	YMOVE
	LD	(UY),A
NOTUP	LD	A,(KEY2)
	AND	1
	JP	Z,NOTDN
	LD	A,(UY)
	CP	54
	JP	NC,NOTDN
	ADD	YMOVE
	LD	(UY),A
NOTDN	LD	A,(SPEED)
	LD	B,A
	XOR	A
	SUB	B
	LD	(ISPEED),A
	RET

PRSC	CALL	PRSC1
	XOR	A
	CALL	COUT
	RET

PRSC1	LD	HL,60928
	LD	(CSR),HL
	LD	HL,OUT1
	PUSH	HL
	LD	HL,(SCORE)
	CALL	14808
	RET

OUT1	INC	HL
OUTP	LD	A,(HL)
	OR	A
	RET	Z
	SUB	48
	PUSH	HL
	CALL	COUT
	POP	HL
	INC	HL
	JP	OUTP

COUT	LD	B,A
	ADD	A
	ADD	A
	ADD	B
	LD	E,A
	LD	D,0
	LD	HL,30561
	ADD	HL,DE
	LD	B,5
	EX	DE,HL
	LD	HL,(CSR)
OUTLP	LD	A,(DE)
	LD	(HL),A
	INC	L
	INC	DE
	DEC	B
	JP	NZ,OUTLP
	INC	L
	LD	(CSR),HL
	RET

CLICK	LD	A,(SNDON)
	OR	A
	RET	Z
	JP	30326

CLS	LD	HL,60672
	LD	DE,60673
	LD	BC,2047
	LD	(HL),0
	JP	27611

MULT	LD	E,L
	LD	D,H
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,DE
	RET

LOAD	LD	L,A
	LD	H,0
	CALL	MULT
	LD	DE,DATA
	ADD	HL,DE
	LD	DE,FLAG
	LD	B,DATANUM
	JP	LDIR

SAVE	LD	L,A
	LD	H,0
	CALL	MULT
	LD	DE,DATA
	ADD	HL,DE
	LD	DE,FLAG
	LD	B,DATANUM
	EX	DE,HL
	JP	LDIR

LDIR	LD	A,(HL)
	LD	(DE),A
	INC	HL
	INC	DE
	DEC	B
	JP	NZ,LDIR
	RET

PLOT	LD	C,0
	LD	B,8
	LD	A,(SHNUM)
	LD	L,A
	LD	H,0
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	LD	DE,SHTABS
	ADD	HL,DE
	LD	(SHPTR),HL
	LD	A,(YP)
	RRC
	RRC
	RRC
	AND	7
	ADD	237
	LD	H,A
	LD	A,(XP)
	LD	L,A
	LD	(SCPTR),HL
PLOTLP	LD	HL,(SHPTR)
	LD	A,(HL)
	INC	HL
	LD	(SHPTR),HL
	LD	L,A
;	LD	A,(MASK)
;	AND	L
;	LD	L,A
	LD	H,0
	LD	A,(YP)
	AND	7
	JP	Z,NOROT
ROTLP	ADD	HL,HL
	DEC	A
	JP	NZ,ROTLP
NOROT	EX	DE,HL
	LD	HL,(SCPTR)
	LD	A,(ONOFF)
	OR	A
	JP	Z,ERASE
	LD	A,(HL)
	AND	E
	OR	C
	LD	C,A
	LD	A,(HL)
	OR	E
	LD	(HL),A
	INC	H
	LD	A,H
	CP	245
	JP	Z,END1
	LD	A,(HL)
	AND	D
	OR	C
	LD	C,A
	LD	A,(HL)
	OR	D
	LD	(HL),A
END1	LD	HL,(SCPTR)
	INC	L
	LD	(SCPTR),HL
	DEC	B
	JP	NZ,PLOTLP
	LD	A,C
	LD	(COLLIS),A
	RET
ERASE	LD	A,E
	CPL
	AND	(HL)
	LD	(HL),A
	INC	H
	LD	A,H
	CP	245
	JP	Z,END1
	L	A,D
	CPL
	AND	(HL)
	LD	(HL),A
	JP	END1

RND	PUSH	HL
	ADC	(HL)
	LD	HL,RR
	ADC	(HL)
	LD	(HL),A
	INC	HL
	ADD	(HL)
	LD	(HL),A
	INC	HL
	ADC	(HL)
	LD	(HL),A
	POP	HL
	RET

PODZ	DFB	3
MENZ	DFB	8
LANDERZ	DFB	5

SHTABS	DFB	8,8,28,127,28,8,8,0
	DFB	34,18,15,18,34,0,0,0
	DFB	32,32,48,40,48,32,48,56
	DFB	56,48,32,48,40,48,32,32
	DFB	196,42,17,241,17,42,196,0
	DFB	196,46,31,255,31,46,196,0
RR	DS	3

SHNUM	DS	1
XP	DS	1
YP	DS	1
ONOFF	DS	1
COLLIS	DS	1
BIGCOL	DS	1
;MASK	DS	1
SCPTR	DS	2
SHPTR	DS	2

FLAG	DS	1
XH	DS	1
X1	DS	1
Y1	DS	1
XM	DS	1
YM	DS	1
TYPE	DS	1
OPT	DS	1
TIME	DS	1

FIRE	DS	1
KEY1	DS	1
KEY2	DS	1
KEYSP	DS	1	BIT 1
SNDON	DS	1
PTR	DS	1
STPTR	DS	1

MENSTAK	DS	16

SHIPS	DS	1
HOLDHL	DS	2
CSR	DS	2
SCORE	DS	2
TMPSP	DS	2
OLDIR	DS	1
DIR	DS	1
YET	DS	1

SPEED	DS	1
ISPEED	DS	1

UX	DS	1
UY	DS	1

WHICH	DS	1
COUNT	DS	1
SPT1	DS	1
	!
0 - EMPTY
1 - POD      1000
2 - MEN
3 - LANDER   250
4 - MUTANT   250
5 - BOMBER   200
6 - SWARMER  250
