;
;  Copyright (C) 2004, Kurt W Dekker, PLBM Games, kwd@plbm.com, www.plbm.com
;
;  This program is free software; you can redistribute it and/or modify
;  it under the terms of the GNU General Public License as published by
;  the Free Software Foundation; either version 2 of the License, or
;  (at your option) any later version.
;
;  This program is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU General Public License for more details.
;
;  You should have received a copy of the GNU General Public License
;  along with this program; if not, write to the Free Software
;  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

;**********************************************************************************************************************
;
; Author:	Kurt W. Dekker
; Started:	Way back when in Punahou and/or Honolulu, Hawaii.
; Updated:	04/24/94
;		11/16/94
; Filename:	GALAXIAN.ASM
;
;**********************************************************************************************************************
;
; 09/16/93:	Put in a few comments.
;
; 04/24/94:	Shareware notice attached.
;
; 11/16/94:	Automatic DUMP.CO check installed.
;
;**********************************************************************************************************************

MS	=	25
MB	=	20
MX	=	30
MAXSPD	=	40
UPD	=	62750

	ORG	55800

; this is all in file CHEKDUMP.INC!!!
; first test for presence of DUMP.CO
	ld	hl,62750
	ld	a,(hl)
	cmp	243
	jp	nz,nodump
	inc	hl
	ld	a,(hl)
	cmp	33
	jp	nz,nodump
	inc	hl
	ld	a,(hl)
	cmp	0
	jp	nz,nodump

	jmp	dumpok
nodump:
	mov	hl,nodumpmsg
	call	10161
dumpwait:
	ei
	call	29250
	cmp	0
	jp	z,dumpwait
	jmp	0

nodumpmsg:
	dm	Must load DUMP first!
	dfb	0

dumpok:
; end of CHEKDUMP.INC!

	LD	A,12
	RST	32
	JP	ENTRY

NEW	CALL	ONETIM
ZZZ	CALL	INIT
MAIN	LD	A,(TOTIND)
	OR	A
	JP	NZ,NOTENSE
	LD	(RELAX),A
NOTENSE	XOR	A
	LD	(65450),A
	CALL	KEYIN
	CALL	TRYBUZ
	LD	HL,A1
	LD	A,(HL)
	OR	A
	JP	Z,NA1
	LD	A,(HL)
	DEC	(HL)
	ADD	A
	ADD	A
	ADD	15
	LD	C,A
	LD	B,25
	CALL	BEEP
NA1	CALL	SHOT
	CALL	YOU
	LD	A,(ALNUM)
	LD	(CTR),A
ALLP	CALL	DO1AL
	LD	HL,CTR
	DEC	(HL)
	JP	NZ,ALLP
	CALL	TRYBUZ
	LD	HL,A2
	LD	A,(HL)
	OR	A
	JP	Z,NA2
	DEC	(HL)
	ADD	A
	ADD	A
	ADD	A
	LD	B,A
	LD	A,140
	SUB	B
	LD	C,A
	LD	B,15
	CALL	BEEP
NA2	CALL	BOMB
	CALL	STAR
	CALL	EXPL
	CALL	TRYBUZ
	LD	HL,A4
	LD	A,(HL)
	OR	A
	JP	Z,NA4
	DEC	(HL)
	ADD	A
	ADD	A
	ADD	A
	LD	B,A
	LD	A,50
	SUB	B
	LD	C,A
	LD	B,20
	CALL	BEEP
NA4	LD	HL,A3
	LD	A,(HL)
	OR	A
	JP	Z,NA3
	DEC	(HL)
	LD	C,15
	LD	B,0
	CALL	BEEP
NA3	CALL	DATA
	call	RND
	CALL	UPD
	LD	HL,DIED
	LD	A,(HL)
	OR	A
	JP	Z,NODECDI
	DEC	(HL)
	CALL	BZ
NODECDI	LD	HL,DEAD
	LD	A,(HL)
	OR	A
	JP	Z,NOPROB
	LD	A,(TOGO)
	OR	A
	JP	NZ,MAK20
	LD	A,(TOTIND)
	OR	A
	JP	Z,NOMAK20
MAK20	LD	(HL),20
NOMAK20	DEC	(HL)
	JP	NZ,NOPROB
	LD	HL,SHIPS
	DEC	(HL)
	JP	Z,ENDGAM
	LD	A,1
	LD	(TEN),A
	XOR	A
	LD	(ONOFF),A
	LD	(XP),A
	LD	A,10
	LD	(SHNUM),A
	LD	A,(UY)
	LD	(YP),A
	CALL	PLOT
	LD	A,28
	LD	(UY),A
NOPROB	LD	A,(CONTIN)
	OR	A
	JP	NZ,MAIN
	LD	HL,TIMER
	DEC	(HL)
	JP	NZ,MAIN
	LD	A,1
	LD	(NEWAV),A
	LD	HL,CURMX
	INC	(HL)
	LD	A,(HL)
	CP	20
	JP	NZ,DOK1
	DEC	(HL)
DOK1	LD	HL,CURFRQ
	INC	(HL)
	LD	A,(HL)
	CP	40
	JP	NZ,DOK2
	DEC	(HL)
DOK2	LD	HL,MAXBOM
	INC	(HL)
	LD	A,(HL)
	CP	MB
	JP	NZ,DOK3
	DEC	(HL)
DOK3	LD	HL,BOMFRQ
	LD	A,(HL)
	ADD	4
	LD	(HL),A
	CP	140
	JP	C,DOK4
	LD	(HL),100
DOK4	LD	HL,ALNUM
	INC	(HL)
	LD	A,(HL)
	CP	MX
	JP	NZ,DOK5
	DEC	(HL)
DOK5	LD	A,(WAVE)
	ADD	A
	LD	B,A
	ADD	A
	ADD	A
	ADD	B
	LD	E,A
	LD	D,0
	LD	HL,(SCORE)
	ADD	HL,DE
	LD	(SCORE),HL
	LD	HL,WAVE
	INC	(HL)
	JP	ZZZ
TRYBUZ	LD	A,(EXS)
	OR	A
	RET	Z
BZ	DI
	LD	B,50
BZL	CALL	RND
	AND	32
	CALL	Z,CLICK
	DEC	B
	JP	NZ,BZL
	RET
BEEP	DI
	LD	A,C
BEEP1	DEC	A
	JP	NZ,BEEP1
	CALL	CLICK
	DEC	B
	JP	NZ,BEEP
	RET
DATA	LD	HL,TOGO
	LD	A,(HL)
	OR	A
	JP	Z,NOINCSC
	DEC	(HL)
	LD	HL,(SCORE)
	INC	HL
	LD	(SCORE),HL
NOINCSC	LD	HL,(BNS)
	EX	DE,HL
	LD	HL,(SCORE)
	RST	24
	JP	C,NOBNS
	LD	A,20
	LD	(A3),A
	LD	HL,500
	ADD	HL,DE
	LD	(BNS),HL
	LD	HL,SHIPS
	INC	(HL)
NOBNS	LD	HL,TEN
	DEC	(HL)
	RET	NZ
	LD	(HL),5
	CALL	DATA1
	XOR	A
	CALL	COUT
	LD	A,76
	LD	(XP),A
	LD	A,56
	LD	(YP),A
	LD	A,16
	LD	(SHNUM),A
	LD	(ONOFF),A
	LD	A,1
	LD	(HITE),A
LEAUP	LD	A,(HITE)
	LD	B,A
	LD	A,(SHIPS)
	CP	B
	JP	NZ,NOZRO
	XOR	A
	LD	(ONOFF),A
NOZRO	CALL	PLOT
	LD	A,(XP)
	ADD	4
	LD	(XP),A
	LD	A,(ONOFF)
	OR	A
	JP	Z,ENLAU
	LD	HL,HITE
	INC	(HL)
	JP	NZ,LEAUP
ENLAU	LD	A,76
	LD	(XP),A
	LD	A,18
	LD	(SHNUM),A
	LD	(ONOFF),A
	LD	A,(WAVE)
	DEC	A
	LD	(LEFT),A
LEWD	LD	A,(LEFT)
	CP	5
	JP	C,CANT5
	CALL	PLOT
	LD	HL,XP
	LD	A,(HL)
	ADD	5
	LD	(HL),A
	LD	HL,LEFT
	LD	A,(HL)
	SUB	5
	LD	(HL),A
	JP	LEWD
CANT5	LD	A,(LEFT)
	OR	A
	RET	Z
	INC	A
	LD	B,A
	LD	A,17
	LD	(SHNUM),A
LAUP	DEC	B
	RET	Z
	PUSH	BC
	CALL	PLOT
	POP	BC
	LD	A,(XP)
	ADD	3
	LD	(XP),A
	JP	LAUP
DATA1	LD	HL,62500
	LD	(CSR),HL
	LD	HL,(SCORE)
	LD	BC,PRLIN
	PUSH	BC
	CALL	14808
	RET
CLICK	LD	A,(SNDON)
	OR	A
	RET	Z
	JP	30326
PRLIN	INC	HL
	LD	A,(HL)
	OR	A
	RET	Z
	SUB	48
	PUSH	HL
	CALL	COUT
	POP	HL
	JP	PRLIN
COUT	LD	B,A
	ADD	A
	ADD	A
	ADD	B
	LD	E,A
	LD	D,0
	LD	HL,30561
	ADD	HL,DE
	EX	DE,HL
	LD	HL,(CSR)
	EX	DE,HL
	LD	BC,5
	CALL	27611
	INC	DE
	EX	DE,HL
	LD	(CSR),HL
	RET
EXPL	LD	A,(EXS)
	OR	A
	RET	Z
	INC	A
	RRC
	AND	127
	ADD	11
	LD	(SHNUM),A
	XOR	A
	LD	(ONOFF),A
	LD	HL,(EXX)
	LD	(XP),HL
	CALL	PLOT
	CALL	BZ
	LD	HL,EXS
	DEC	(HL)
	RET	Z
	LD	A,(HL)
	INC	A
	RRC
	AND	127
	ADD	11
	LD	(SHNUM),A
	LD	(ONOFF),A
	LD	HL,EXX
	DEC	(HL)
	DEC	(HL)
	LD	HL,XP
	DEC	(HL)
	DEC	(HL)
	CALL	PLOT
	RET
DO1AL	LD	HL,ALPTR
	INC	(HL)
	LD	A,(HL)
	CP	MX
	JP	NZ,NORST
	LD	(HL),0
	LD	A,(DUNWUN)
	LD	(CONTIN),A
	OR	A
	JP	NZ,NOSETIM
	LD	A,(TIMER)
	OR	A
	JP	NZ,NOSETIM
	LD	A,50
	LD	(TIMER),A
NOSETIM	XOR	A
	LD	(DUNWUN),A
	LD	HL,TOGL
	INC	(HL)
	LD	HL,SETTLE
	LD	A,(HL)
	OR	A
	JP	Z,NODECS
	DEC	(HL)
NODECS	LD	A,(OFSET)
	ADD	3
	CP	28
	JP	C,NORST
	LD	A,(CURMV)
	CPL
	INC	A
	LD	(CURMV),A
	XOR	A
	LD	(REVIT),A
NORST	LD	A,(ALPTR)
	LD	E,A
	LD	D,0
	OR	A
	JP	NZ,NOADDIT
	LD	A,(SETTLE)
	OR	A
	JP	NZ,NOADDIT
	LD	A,(CURMV)
	LD	HL,OFSET
	ADD	(HL)
	LD	(HL),A
NOADDIT	LD	HL,ALF
	ADD	HL,DE
	LD	A,(HL)
	OR	A
	RET	Z
	LD	A,(BUZZ)
	INC	A
	LD	(BUZZ),A
	AND	7
	PUSH	DE
	CALL	Z,CLICK
	POP	DE
	LD	A,50
	LD	(TIMER),A
	LD	A,1
	LD	(DUNWUN),A
	LD	HL,ALX
	ADD	HL,DE
	LD	A,(HL)
	LD	(XP),A
	LD	HL,ALY
	ADD	HL,DE
	LD	A,(HL)
	LD	(YP),A
	LD	A,(SETTLE)
	OR	A
	JP	Z,NOSETT
	LD	HL,ALX
	ADD	HL,DE
	LD	A,(HL)
	SUB	2
	LD	(HL),A
	JP	NOSETR
NOSETT	PUSH	HL
	LD	HL,ALF
	ADD	HL,DE
	LD	A,(HL)
	CP	2
	JP	NZ,NODI1
	CALL	RND
	LD	HL,BOMFRQ
	CP	(HL)
	JP	NC,NODROP
	LD	A,(DEAD)
	OR	A
	JP	NZ,NODROP
	LD	HL,ALX
	ADD	HL,DE
	LD	A,(HL)
	CP	30
	JP	C,NODROP
	LD	(RPX),A
	LD	A,1
	LD	(REQ),A
	LD	HL,ALY
	ADD	HL,DE
	LD	A,(HL)
	ADD	2
	LD	(RPY),A
NODROP	LD	HL,ALMX
	ADD	HL,DE
	LD	A,(HL)
	CP	18
	JP	Z,ZROIT
	INC	A
	LD	(HL),A
	JP	NOSTO1
ZROIT	LD	B,A
	CALL	RND
	AND	3
	INC	A
	LD	C,A
	LD	A,B
	SUB	C
	LD	(HL),A
NOSTO1	RRC
	AND	63
	SUB	4
	LD	B,A
	LD	HL,ALX
	ADD	HL,DE
	LD	A,(HL)
	SUB	B
	LD	(HL),A
	LD	B,A
	LD	A,(SHX)
	SUB	B
	LD	B,A
	LD	HL,ALMY
	ADD	HL,DE
	LD	A,(HL)
	CP	2
	JP	Z,DECEL
	CP	254
	JP	Z,ACCEL
	CALL	RND
	AND	4
	JP	NZ,NOCHASE
	PUSH	HL
	LD	HL,ALY
	ADD	HL,DE
	LD	A,(HL)
	LD	HL,UY
	CP	(HL)
	POP	HL
	LD	A,(HHH)
	OR	A
	JP	Z,NOCCF
	LD	A,B
	AND	128
	JP	Z,NOCCF
	CCF
NOCCF	JP	C,ACCEL
	JP	DECEL
NOCHASE	CALL	RND
	AND	16
	JP	Z,DECEL
ACCEL	INC	(HL)
	INC	(HL)
DECEL	DEC	(HL)
	LD	A,(HL)
	POP	HL
	LD	B,(HL)
	ADD	(HL)
	LD	(HL),A
	SUB	3
	CP	53
	JP	C,NOREV1
	LD	(HL),B
	LD	HL,ALMY
	ADD	HL,DE
	LD	A,(HL)
	CPL
	INC	A
	LD	(HL),A
NOREV1	LD	HL,ALX
	ADD	HL,DE
	LD	A,(HL)
	CP	239
	JP	C,NOSETR
	LD	(HL),239
	LD	HL,TOTIND
	DEC	(HL)
	LD	HL,ALF
	ADD	HL,DE
	LD	(HL),3
	LD	HL,ORGY
	ADD	HL,DE
	LD	A,(HL)
	LD	HL,OFSET
	ADD	(HL)
	LD	HL,ALY
	ADD	HL,DE
	LD	(HL),A
	JP	NOSETR
NODI1	CP	3
	JP	NZ,NODI2
	LD	HL,ALX
	ADD	HL,DE
	DEC	(HL)
	LD	A,(HL)
	LD	HL,SUBTR
	ADD	(HL)
	LD	HL,ORGX
	ADD	HL,DE
	CP	(HL)
	JP	NZ,NOCHNG
	LD	HL,ALF
	ADD	HL,DE
	LD	(HL),1
NOCHNG	POP	HL
	LD	A,(CURMV)
	ADD	(HL)
	LD	(HL),A
	JP	NOSETR
NODI2	POP	HL
	LD	A,(CURMV)
	ADD	(HL)
	LD	(HL),A
NOSETR	LD	A,(TOGL)
	CPL
	AND	1
	LD	HL,ALS
	ADD	HL,DE
	ADD	(HL)
	LD	(SHNUM),A
	XOR	A
	LD	(ONOFF),A
	PUSH	DE
	CALL	PLOT
	POP	DE
	LD	HL,ALX
	ADD	HL,DE
	LD	A,(HL)
	LD	(XP),A
	LD	HL,ALY
	ADD	HL,DE
	LD	A,(HL)
	LD	(YP),A
	LD	A,(TOGL)
	AND	1
	LD	HL,ALS
	ADD	HL,DE
	ADD	(HL)
	LD	(SHNUM),A
	LD	A,1
	LD	(ONOFF),A
	PUSH	DE
	CALL	PLOT
	POP	DE
	LD	A,(DEAD)
	OR	A
	JP	NZ,NOCHANC
	LD	A,(COLLIS)
	OR	A
	JP	Z,NOCHANC
	LD	A,(XP)
	CP	7
	JP	NC,NOCHANC
	LD	A,(YP)
	ADD	4
	LD	HL,UY
	SUB	(HL)
	CP	9
	JP	NC,NOCHANC
	LD	A,10
	LD	(SHNUM),A
	XOR	A
	LD	(ONOFF),A
	PUSH	DE
	CALL	PLOT
	POP	DE
	CALL	ADDSC
	CALL	SETEX
	LD	A,20
	LD	(DEAD),A
	LD	(DIED),A
NOCHANC	LD	A,(WAVE)
	CP	4
	JP	C,NOTSTR
	LD	A,(RELAX)
	OR	A
	RET	NZ
NOTSTR	LD	A,(SETTLE)
	OR	A
	RET	NZ
	LD	A,(TOTIND)
	LD	HL,CURMX
	OR	A
	JP	Z,DIVE
	CP	(HL)
	JP	C,DIVOT
	LD	A,1
	LD	(RELAX),A
	RET
DIVOT	CALL	RND
	ADD	45
	LD	HL,CURFRQ
	CP	(HL)
	RET	NC
DIVE	LD	A,(DEAD)
	OR	A
	RET	NZ
	LD	HL,ALF
	ADD	HL,DE
	LD	A,(HL)
	CP	1
	RET	NZ
	LD	A,15
	LD	(A2),A
	LD	(HL),2
	LD	HL,ALMX
	ADD	HL,DE
	LD	(HL),1
	LD	HL,ALMY
	ADD	HL,DE
	LD	(HL),0
	LD	HL,TOTIND
	INC	(HL)
	RET
STAR	XOR	A
	LD	(PTR),A
STARLP	LD	A,(PTR)
	LD	E,A
	LD	D,0
	LD	HL,SWX
	ADD	HL,DE
	LD	A,(HL)
	LD	(XP),A
	PUSH	HL
	LD	HL,SWY
	ADD	HL,DE
	LD	A,(HL)
	LD	(YP),A
	LD	HL,SWMX
	ADD	HL,DE
	LD	A,(HL)
	POP	HL
	ADD	(HL)
	LD	(HL),A
	PUSH	DE
	CALL	EDOT
	POP	DE
	LD	HL,SWX
	ADD	HL,DE
	LD	A,(HL)
	LD	(XP),A
	CP	239
	JP	C,NONWY
	LD	(HL),239
	LD	HL,SWMX
	ADD	HL,DE
	CALL	RND
	AND	3
	CPL
	SUB	2
	LD	(HL),A
	CALL	RND
	AND	63
	LD	HL,SWY
	ADD	HL,DE
	LD	(HL),A
NONWY	LD	HL,SWY
	ADD	HL,DE
	LD	A,(HL)
	LD	(YP),A
	CALL	PDOT
	LD	HL,PTR
	INC	(HL)
	LD	A,(HL)
	CP	MS
	JP	NZ,STARLP
	RET
BOMB	XOR	A
	LD	(PTR),A
BOMBLP	LD	A,(PTR)
	LD	E,A
	LD	D,0
	LD	HL,BF
	ADD	HL,DE
	LD	A,(HL)
	OR	A
	JP	NZ,DOBOMB
	LD	A,(REQ)
	OR	A
	JP	Z,ENDBOMB
	LD	(HL),1
	LD	A,6
	LD	(A4),A
	XOR	A
	LD	(REQ),A
	LD	A,(RPX)
	LD	HL,BX
	ADD	HL,DE
	LD	(HL),A
	LD	A,(RPY)
	LD	HL,BY
	ADD	HL,DE
	LD	(HL),A
AG3	CALL	RND
	AND	3
	JP	Z,AG3
	SUB	2
	LD	HL,BMY
	ADD	HL,DE
	LD	(HL),A
DOBOMB	LD	HL,BX
	ADD	HL,DE
	LD	A,(HL)
	LD	(XP),A
	SUB	4
	LD	(HL),A
	LD	HL,BY
	ADD	HL,DE
	LD	A,(HL)
	LD	(YP),A
	PUSH	HL
	LD	HL,BMY
	ADD	HL,DE
	ADD	(HL)
	POP	HL
	LD	(HL),A
	XOR	A
	LD	(ONOFF),A
	LD	A,11
	LD	(SHNUM),A
	PUSH	DE
	CALL	PLOT
	POP	DE
	LD	HL,BX
	ADD	HL,DE
	LD	A,(HL)
	LD	(XP),A
	CP	239
	JP	C,NOBOMEN
	LD	HL,BF
	ADD	HL,DE
	LD	(HL),0
	JP	ENDBOMB
NOBOMEN	LD	HL,BY
	ADD	HL,DE
	LD	A,(HL)
	LD	(YP),A
	DEC	A
	CP	61
	JP	C,NOSTOP
	LD	HL,BMY
	ADD	HL,DE
	XOR	A
	SUB	(HL)
	LD	(HL),A
NOSTOP	LD	A,1
	LD	(ONOFF),A
	CALL	PLOT
	LD	A,(DEAD)
	OR	A
	JP	NZ,ENDBOMB
	LD	A,(XP)
	CP	7
	JP	NC,ENDBOMB
	LD	A,(YP)
	LD	HL,UY
	SUB	(HL)
	CP	5
	JP	NC,ENDBOMB
	LD	A,20
	LD	(DIED),A
	LD	(DEAD),A
ENDBOMB	LD	HL,PTR
	INC	(HL)
	LD	A,(HL)
	LD	HL,MAXBOM
	CP	(HL)
	JP	NZ,BOMBLP
	XOR	A
	LD	(REQ),A
	RET
RND	PUSH	HL
	ADC	(HL)
	LD	HL,XP
	SBC	(HL)
	LD	HL,RR
	ADC	(HL)
	LD	(HL),A
	INC	HL
	ADD	(HL)
	LD	(HL),A
	INC	HL
	ADC	(HL)
	LD	(HL),A
	POP	HL
	RET
PDOT	CALL	CALC
	OR	(HL)
	LD	(HL),A
	RET
EDOT	CALL	CALC
	CPL
	AND	(HL)
	LD	(HL),A
	RET
CALC	LD	A,(XP)
	LD	L,A
	LD	A,(YP)
	RRC
	RRC
	RRC
	AND	7
	ADD	237
	LD	H,A
	PUSH	HL
	LD	A,(YP)
	AND	7
	LD	E,A
	LD	D,0
	LD	HL,BITS
	ADD	HL,DE
	LD	A,(HL)
	POP	HL
	RET
SHOT	LD	A,(HHH)
	OR	A
	JP	NZ,DOSHOT
	LD	A,(DEAD)
	OR	A
	RET	NZ
	LD	A,(FIRE)
	OR	A
	RET	Z
	LD	(HHH),A
	LD	A,22
	LD	(A1),A
	XOR	A
	LD	(SHX),A
	LD	A,(UY)
	LD	(SHY),A
DOSHOT	LD	HL,(SHX)
	LD	(XP),HL
	LD	A,1
	LD	(SHNUM),A
	XOR	A
	LD	(ONOFF),A
	CALL	PLOT
	LD	A,(SHX)
	ADD	7
	LD	(SHX),A
	LD	(XP),A
	CP	239
	JP	NC,QUITSH
	LD	(ONOFF),A
	CALL	PLOT
	LD	A,(COLLIS)
	OR	A
	RET	Z
	XOR	A
	LD	(CHKPTR),A
CHKLP	LD	A,(CHKPTR)
	LD	E,A
	LD	D,0
	LD	HL,ALF
	ADD	HL,DE
	LD	A,(HL)
	OR	A
	JP	Z,NOCHK
	LD	A,(YP)
	ADD	4
	LD	HL,ALY
	ADD	HL,DE
	SUB	(HL)
	CP	9
	JP	NC,NOCHK
	LD	A,(XP)
	ADD	9
	LD	HL,ALX
	ADD	HL,DE
	SUB	(HL)
	CP	18
	JP	NC,NOCHK
	CALL	ADDSC
	LD	A,1
	LD	(SHNUM),A
	XOR	A
	LD	(HHH),A
	LD	(ONOFF),A
	PUSH	DE
	CALL	PLOT
	POP	DE
	LD	HL,ALX
	ADD	HL,DE
	LD	A,(HL)
	LD	(XP),A
	LD	HL,ALY
	ADD	HL,DE
	LD	A,(HL)
	LD	(YP),A
	CALL	SETEX
	LD	A,10
	LD	(SHNUM),A
	CALL	PLOT
NOCHK	LD	HL,CHKPTR
	INC	(HL)
	LD	A,(HL)
	CP	MX
	JP	NZ,CHKLP
	RET
ADDSC	LD	HL,ALF
	ADD	HL,DE
	LD	A,(HL)
	LD	(HL),0
	CP	1
	JP	Z,SCORF
	CP	2
	JP	NZ,NODECTO
	LD	HL,TOTIND
	DEC	(HL)
NODECTO	LD	HL,SC1
	JP	SCORD
SCORF	LD	HL,SC2
SCORD	ADD	HL,DE
	LD	A,(HL)
	LD	HL,TOGO
	ADD	(HL)
	LD	(HL),A
	RET
SETEX	LD	A,(EXS)
	OR	A
	JP	Z,DOEX
	LD	HL,(XP)
	PUSH	HL
	LD	HL,(EXX)
	LD	(XP),HL
	LD	A,10
	LD	(SHNUM),A
	PUSH	DE
	CALL	PLOT
	POP	DE
	POP	HL
	LD	(XP),HL
DOEX	LD	HL,(XP)
	LD	(EXX),HL
	LD	A,7
	LD	(EXS),A
	RET
QUITSH	XOR	A
	LD	(HHH),A
	RET
YOU	XOR	A
	LD	(UMV),A
	LD	A,(DEAD)
	OR	A
	JP	NZ,NOTDN
	LD	A,(KEY1)
	AND	127
	JP	Z,NOTUP
	LD	A,254
	LD	(UMV),A
NOTUP	LD	A,(KEY2)
	AND	127
	JP	Z,NOTDN
	LD	A,2
	LD	(UMV),A
NOTDN	XOR	A
	LD	(ONOFF),A
	LD	(SHNUM),A
	LD	A,(DEAD)
	OR	A
	JP	Z,OKY
	LD	A,10
	LD	(SHNUM),A
OKY	XOR	A
	LD	(XP),A
	LD	A,(UY)
	LD	(YP),A
	CALL	PLOT
	LD	A,(UMV)
	LD	HL,UY
	ADD	(HL)
	CP	59
	JP	NC,NOSTO
	LD	(HL),A
NOSTO	LD	A,(HL)
	LD	(YP),A
	LD	A,1
	LD	(ONOFF),A
	LD	A,(DEAD)
	OR	A
	JP	Z,OKY1
	CALL	RND
	AND	3
	ADD	12
	LD	(SHNUM),A
OKY1	LD	A,(DEAD)
	OR	A
	JP	Z,DOPLOT
	LD	A,(DIED)
	OR	A
	RET	Z
DOPLOT	CALL	PLOT
	RET
ENDGAM	LD	HL,MSG1
	LD	DE,61537
	LD	BC,44
	CALL	27611
	LD	B,44
	LD	HL,61281
ENDLP	LD	(HL),128
	INC	L
	DEC	B
	JP	NZ,ENDLP
	LD	A,1
	LD	(SHIPS),A
	LD	(TEN),A
	CALL	DATA
	LD	HL,MSG3
	CALL	10161
	LD	HL,(SCORE)
	CALL	14804
	LD	A,48
	RST	32
	CALL	UPD
	DI
	LD	B,0
BH1	LD	C,12
BH2	LD	A,B
BH3	DEC	A
	JP	NZ,BH3
	CALL	CLICK
	DEC	C
	JP	NZ,BH2
	INC	B
	JP	NZ,BH1
	LD	B,1
BH6	LD	C,10
BH7	CALL	RND
	CP	B
	CALL	C,CLICK
	DEC	C
	JP	NZ,BH7
	INC	B
	LD	A,B
	CP	200
	JP	NZ,BH6
BH4	LD	C,30
BH5	CALL	RND
	CP	B
	CALL	C,CLICK
	DEC	C
	JP	NZ,BH5
	DEC	B
	JP	NZ,BH4

ENTRY:
	LD	HL,MSG2
	CALL	10161
	ld	hl,(score)
	call	14804
	ld	a,48
	call	32
WAIT:
	inc	hl
	ld	a,(hl)
	CALL	RND
	CALL	29250
	CP	13
	JP	NZ,WAIT
	JP	NEW

ONETIM:
	LD	HL,500
	LD	(BNS),HL
	LD	HL,0
	LD	(A1),HL
	XOR	A
	LD	(A3),A
	LD	(TOGO),A
	LD	(HHH),A
	LD	(DIED),A
	LD	(DEAD),A
	LD	A,1
	LD	(WAVE),A
	LD	A,16
	LD	(ALNUM),A
	LD	A,28
	LD	(UY),A
	LD	A,1
	LD	(NEWAV),A
	LD	HL,0
	LD	(SCORE),HL
	LD	A,4
	LD	(SHIPS),A
	LD	A,1
	LD	(CURFRQ),A
	LD	A,14
	LD	(BOMFRQ),A
	LD	A,3
	LD	(CURMX),A
	LD	A,3
	LD	(MAXBOM),A
	LD	B,MS
	LD	HL,SWX
	LD	DE,SWMX
INSW	CALL	RND
	LD	(HL),A
	CALL	RND
	AND	3
	CPL
	SUB	3
	LD	(DE),A
	INC	DE
	INC	HL
	DEC	B
	JP	NZ,INSW
	RET
INIT	XOR	A
	LD	(EXS),A
	LD	(OFSET),A
	LD	(REQ),A
	LD	(TOTIND),A
	CPL
	LD	(CONTIN),A
	LD	(ALPTR),A
	CALL	CLS

	LD	B,MB
	LD	HL,BF
	XOR	A
INBL	LD	(HL),A
	INC	HL
	DEC	B
	JP	NZ,INBL

	LD	A,(NEWAV)
	OR	A
	RET	Z
	LD	A,(WAVE)
	ADD	A
	ADD	A
	ADD	10
	LD	(SETTLE),A
	ADD	A
	LD	(SUBTR),A
	LD	A,1
	LD	(TEN),A
	LD	(CURMV),A
	XOR	A
	LD	(NEWAV),A
	LD	A,MX
	ADD	A
	ADD	A
	LD	C,A
	LD	B,0
	LD	HL,PATTERN
	LD	DE,ALF
	JP	27611
CLS	LD	HL,60672
	LD	DE,60673
	LD	BC,2047
	LD	(HL),0
	JP	27611
PLOT	LD	C,0
	LD	B,8
	LD	A,(SHNUM)
	LD	L,A
	LD	H,0
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	LD	DE,SHTABS
	ADD	HL,DE
	LD	(SHPTR),HL
	LD	A,(YP)
	RRC
	RRC
	RRC
	AND	7
	ADD	237
	LD	H,A
	LD	A,(XP)
	LD	L,A
	LD	(SCPTR),HL
PLOTLP	LD	HL,(SHPTR)
	LD	A,(HL)
	INC	HL
	LD	(SHPTR),HL
	LD	L,A
	LD	H,0
	LD	A,(YP)
	AND	7
	JP	Z,NOROT
ROTLP	ADD	HL,HL
	DEC	A
	JP	NZ,ROTLP
NOROT	EX	DE,HL
	LD	HL,(SCPTR)
	LD	A,(ONOFF)
	OR	A
	JP	Z,ERASE
	LD	A,(HL)
	AND	E
	OR	C
	LD	C,A
	LD	A,(HL)
	OR	E
	LD	(HL),A
	INC	H
	LD	A,H
	CP	245
	JP	Z,END1
	LD	A,(HL)
	AND	D
	OR	C
	LD	C,A
	LD	A,(HL)
	OR	D
	LD	(HL),A
END1	LD	HL,(SCPTR)
	INC	L
	LD	(SCPTR),HL
	DEC	B
	JP	NZ,PLOTLP
	LD	A,C
	LD	(COLLIS),A
	RET
ERASE	LD	A,E
	CPL
	AND	(HL)
	LD	(HL),A
	INC	H
	LD	A,H
	CP	245
	JP	Z,END1
	LD	A,D
	CPL
	AND	(HL)
	LD	(HL),A
	JP	END1


KEYIN	DI
	IN	178
	AND	254
	OUT	178
	LD	A,255
	OUT	177
	IN	225
	CPL
	LD	B,A
	AND	16
	JP	NZ,KEYIN	; causes a pause
	LD	A,B
	AND	32
	LD	(SNDON),A
	IN	178
	OR	1
	OUT	178
	LD	A,191
	OUT	177
	IN	225
	CPL
	LD	(KEYSP),A
	AND	1
	LD	(FIRE),A
	LD	A,254
	OUT	177
	IN	225
	CPL
	LD	(KEY2),A
	LD	A,253
	OUT	177
	IN	225
	CPL
	LD	(KEY1),A
	EI
	RET


MSG3	DFB	11,10,10,10,10,10,10,10
	DM
	DFB	0
MSG2	DFB	12,13,27,112
	DM	Galaxian
	DFB	27,113
	DM	- A Shameless Shareware Ripoff!
	DFB	13,10,10
	DM	Send $5 Reg to: Kurt W. Dekker
	DFB	13,10,9,9
	DM	PO Box 10342
	DFB	13,10,9,9
	DM	Costa Mesa, CA  92627
	DFB	13,10,10
	DM	Started in 1985 in high school
	DFB	13,10
	DM	Hit <Enter> ... Last Score:
	DFB	0
MSG1	DFB	255,128,190,162,186,128
	DFB	190,138,190,128,190,132
	DFB	190,128,190,170,162,128
	DFB	128,128,128,128,190,162
	DFB	190,128,158,160,158,128
	DFB	190,170,162,128,190,154
	DFB	174,128,128,174,128,174
	DFB	128,255
BITS	DFB	1,2,4,8,16,32,64,128
SC1	DFB	4,4,4,4,4,4,4,4,4,4
	DFB	5,5,5,5,5,6,6,6,6,6,7,7
	DFB	7,7,7,10,10,10,20,20
SC2	DFB	1,1,1,1,1,1,1,1,1,1
	DFB	2,2,2,2,2,2,2,2,2,2
	DFB	3,3,3,3,3,4,4,4,5,5
SHTABS	DFB	17,27,31,27,31,14,4,4
	DFB	4,14,4,31,4,14,4,0
	DFB	4,10,19,7,7,19,10,4
	DFB	0,30,3,7,7,3,30,0
	DFB	2,7,29,23,7,29,23,2
	DFB	2,23,29,7,23,29,7,2
	DFB	28,6,19,30,30,19,6,28
	DFB	7,12,25,15,15,25,12,7
	DFB	4,4,14,27,21,31,4,4
	DFB	14,4,14,27,21,14,10,17
	DFB	31,31,31,31,31,31,31,31
	DFB	1,1,1,1,1,0,0,0
	DFB	0,4,21,14,14,21,4,0
	DFB	17,10,10,4,4,10,10,17
	DFB	4,14,27,14,14,27,14,4
	DFB	10,21,10,4,4,10,21,10
	DFB	128,192,128,0,0,0,0,0
	DFB	30,6,0,0,0,0,0,0
	DFB	31,5,5,7,0,0,0,0
PATTERN	DFB	1,1,1,1,1,1,1,1,1,1
	DFB	1,1,1,1,1,1,1,1,1,1
	DFB	1,1,1,1,1,1,1,1,1,1
ORGX	DFB	182,182,182,182,182
	DFB	193,193,193,193,193
	DFB	204,204,204,204,204
	DFB	215,215,215,215,215
	DFB	226,226,226,226,226
	DFB	237,237,237,248,248
ORGY	DFB	5,12,19,26,33
	DFB	5,12,19,26,33
	DFB	5,12,19,26,33
	DFB	5,12,19,26,33
	DFB	5,12,19,26,33
	DFB	12,19,26,12,26
	DFB	2,2,2,2,2,2,2,2,2,2
	DFB	4,4,4,4,4,4,4,4,4,4
	DFB	6,6,6,6,6,6,6,6,8,8
RR	DS	3
BNS	DS	2
CSR	DS	2
SCORE	DS	2
RELAX	DS	1
SUBTR	DS	1
LEFT	DS	1
SETTLE	DS	1
BUZZ	DS	1
A1	DS	1
A2	DS	1
A3	DS	1
A4	DS	1
SNDON	DS	1
TEN	DS	1
HITE	DS	1
ALNUM	DS	1
WAVE	DS	1
SHIPS	DS	1
DIED	DS	1
DEAD	DS	1
TIMER	DS	1
BOMFRQ	DS	1
NEWAV	DS	1
EXX	DS	1
EXY	DS	1
EXS	DS	1
PTR	DS	1
REQ	DS	1
RPX	DS	1
RPY	DS	1
OFSET	DS	1
CONTIN	DS	1
DUNWUN	DS	1
TOGO	DS	1
CURMX	DS	1
CURFRQ	DS	1
MAXBOM	DS	1
TOTIND	DS	1
TOGL	DS	1
REVIT	DS	1
CURMV	DS	1
CTR	DS	1
CHKPTR	DS	1
ALPTR	DS	1
SHX	DS	1
SHY	DS	1
HHH	DS	1
FIRE	DS	1
KEY1	DS	1
KEY2	DS	1
KEYSP	DS	1
UMV	DS	1
UY	DS	1
XP	DS	1
YP	DS	1
SHNUM	DS	1
ONOFF	DS	1
COLLIS	DS	1
SHPTR	DS	2
SCPTR	DS	2
BF	DS	MB
BX	DS	MB
BY	DS	MB
BMY	DS	MB
SWX	DS	MS
SWY	DS	MS
SWMX	DS	MS
ALF	DS	MX
ALX	DS	MX
ALY	DS	MX
ALS	DS	MX
ALMX	DS	MX
ALMY	DS	MX
